/*--------------------------------------------------------------------.
| fileselect.c                                                        |
|                                                                     |
| (c) 1997 Christopher Cave and Jonathan Hudson                       |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68                   |
|                                                                     |
| Authors:                                                            |
|    Christopher Cave    <ccave@cix.compulink.co.uk>                  |
|    Jonathan Hudson     <jrhudson@bigfoot.com>                       |
| Bug fixes and improvements:                                         |
|    Thierry Godefroy    <godefroy@imaginet.fr>                       |
 --------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "menu.h"
#include "menuP.h"

int FileSelect (char *prompt, char *dir, char *ext, char *buf,
                short size, int xpos, int ypos, int mainc, int filec)
{
    int iret;

    QD_TEXT (39) menustr;
    QD_TEXT (39) basestr;
    QD_TEXT (39) dirstr;
    QD_TEXT (39) rsltstr;
    QD_TEXT (39) extstr;

    MENUFSEL s;

    s.mennm.attr = THP_CALL | THP_STR;
    s.mennm.info = 0;
    s.mennm.ptr = &menustr;

    s.defnm.attr = THP_CALL | THP_STR;
    s.defnm.info = 0;
    s.defnm.ptr = &basestr;

    s.dirnm.info = 0;
    if((long)dir > 0)
    {
        s.dirnm.attr = THP_CALL | THP_STR | THP_UPD;
        s.dirnm.ptr = &dirstr;
        MOVEINS (&dirstr, dir);
    }
    else 
    {
        s.dirnm.attr = THP_CALL|THP_SLNG;
        s.dirnm.ptr = dir;
    }
    s.extnm.attr = THP_CALL | THP_STR | THP_UPD;
    s.extnm.info = 0;
    s.extnm.ptr = &extstr;

    s.fname.attr = THP_RET | THP_STR;
    s.fname.info = 0;
    s.fname.ptr = &rsltstr;

    MOVEINS (&menustr, prompt);
    MOVEINS (&basestr, buf);
    MOVEINS (&extstr, ext);

    s.size = size;
    s.xpos = xpos;
    s.ypos = ypos;
    s.mainc = mainc;
    s.filec = filec;

    rsltstr.len = 0;

    iret = _use_qmenu(FSEL, &s);
    if (iret >= 0)
    {
        RESTORES (buf, &rsltstr);
        if((long)dir > 0)
        {
            RESTORES (dir, &dirstr);
        }
        RESTORES (ext, &extstr);
    }
    return iret;
}
