/*--------------------------------------------------------------------.
| getscrap.c                                                          |
|                                                                     |
| (c) 1997 Christopher Cave and Jonathan Hudson                       |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68                   |
|                                                                     |
| Authors:                                                            |
|    Christopher Cave    <ccave@cix.compulink.co.uk>                  |
|    Jonathan Hudson     <jrhudson@bigfoot.com>                       |
| Bug fixes and improvements:                                         |
|    Thierry Godefroy    <godefroy@imaginet.fr>                       |
 --------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "menu.h"
#include "menuP.h"

int GetScrap (unsigned char dtyp, void *dataptr, unsigned long buflen,
              SCRAP_CB_t func)
{
    SCRAPGET sg;
    SFUNC_t f;
    ACTION_t a;

    sg.opt = THP_OPT | THP_UBYT;
    sg.pack = 0;
    sg.dtyp = dtyp;
    sg.dest = dataptr;
    sg.bufl = buflen;
    if(func)
    {
        a.jsr = JSR;
        a.interface = _scrap_act;
        a.function = &f;
        f.func = func;
        f.param = &sg.dest;
        sg.uccd = &a;
    }
    else
        sg.uccd = NULL;

    return(_use_scrap(GET, &sg));
}
