/*--------------------------------------------------------------------.
| listselect.c                                                        |
|                                                                     |
| (c) 1997 Christopher Cave and Jonathan Hudson                       |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68                   |
|                                                                     |
| Authors:                                                            |
|    Christopher Cave    <ccave@cix.compulink.co.uk>                  |
|    Jonathan Hudson     <jrhudson@bigfoot.com>                       |
| Bug fixes and improvements:                                         |
|    Thierry Godefroy    <godefroy@imaginet.fr>                       |
 --------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "menu.h"
#include "menuP.h"


int ListSelect (char *name, char **items, int nitems, int mictl,
                int lines, int colms, int xpos, int ypos,
                int mainc, int listc, short *sts)
{
    int iret = ERR_OM;
    int i;
    short retn;
    ARRAYDESC desc,sdesc;
    char *tmp;
    QD_TEXT (39) menustr;
    MENULIST ls;
    int ns, maxlen = 0;

    for (i = 0; i < nitems; i++)
    {
        ns = strlen(*(items+i));
        if(ns > maxlen) maxlen = ns;
    }

    maxlen = (maxlen + 1) & ~1;
    if ((tmp = malloc (nitems * (maxlen + 2))))
    {
        char *q = tmp;
        for (i = 0; i < nitems; i++, items++)
        {
            MOVEINS (q, *items);
            q += (maxlen + 2);
        }
        
        ls.mennm.info = 0;
        if (name)
        {
            ls.mennm.attr = THP_CALL | THP_STR;
            ls.mennm.ptr = &menustr;
            MOVEINS (&menustr, name);
        }
        else
        {
            ls.mennm.attr = 0;
            ls.mennm.ptr = NULL;
        }
        
        ls.itlst.attr = THP_CALL | THP_ARR | THP_STR;
        ls.itlst.info = 0;
        ls.itlst.ptr = &desc;
        
        ls.stlst.info = 0;
        if(sts)
        {
            ls.stlst.attr = THP_UPD | THP_ARR | THP_UWRD;
            ls.stlst.ptr = &sdesc;
            sdesc.ptr = (void *) sts;
            sdesc.ndims = 1;
            sdesc.nitems0 = nitems - 1;
            sdesc.mult0 = sizeof(short);
        }
        else
        {
            ls.stlst.attr = 0;
            ls.stlst.ptr = NULL;
        }
        
        ls.mictl = mictl;
        ls.lines = lines;
        ls.colms = colms;
        ls.xpos = xpos;
        ls.ypos = ypos;
        ls.mainc = mainc;
        ls.listc = listc;
        
        ls.retn.attr = THP_RET | THP_UWRD;
        ls.retn.info = 0;
        ls.retn.ptr = &retn;
        retn = 0;
        
        desc.ptr = (void *) tmp;
        desc.ndims = 2;
        desc.nitems0 = nitems - 1;
        desc.mult0 = maxlen + 2;
        desc.nitems1 = maxlen;
        desc.mult1 = 1;

        i = _use_qmenu(LIST, &ls);
        if (i >= 0)
            iret = retn;
        else
            ReportError (iret = i, 0, 0, -1);
        free (tmp);
    }

    return iret;
}
