* ut.asm
*
* Use routines for the QMenu and Scrap extension things.
* (c) 30/12/1999 Thierry Godefroy.
*
* int _use_qmenu(char *extension, void *parameter_list);
* int _use_scrap(char *extension, void *parameter_list);
*
* Note: the extension name MUST be 4 characters long (pad it with spaces if
*       it is three charcaters long or less).

          section   TEXT

          comment   "C68 libqmenu_a v1.05"

          xdef      __use_qmenu
          xdef      __use_scrap

__use_scrap
          LEA       SCRAP,A0                      Thing name.
          BRA.S     USEQMENU1                     Call this thing.
__use_qmenu
          LEA       QMENU,A0                      Thing name.
USEQMENU1 MOVEM.L   D3-D7/A2-A6,-(SP)             Save the context.
          MOVE.L    A0,D7                         Save the ptr on thing name.
          LEA       44(SP),A5                     Pointer on parameters.
          MOVEA.L   (A5)+,A1                      Pointer on extension name.
          MOVEQ     #3,D0                         DBRA counter (4 chars).
USEQMENU2 LSL.L     #8,D2                         Room for next character.
          MOVE.B    (A1)+,D2                      Get a character.
          DBRA      D0,USEQMENU2                  Next character.
          BSR.S     USE_THING                     Use the thing.
          BNE.S     USEQMENU3                     If error, return now.
          LEA       $18(A1),A4                    Vector for the extension.
          MOVEA.L   (A5),A1                       Pointer on the parameter list.
          JSR       (A4)                          Call the extension.
          MOVE.L    D0,D4                         Save the error code.
          MOVEA.L   D7,A0                         Get back ptr on thing name.
          BSR.S     FREE_THG                      Free the thing.
          MOVE.L    D4,D0                         Restore the error code
USEQMENU3 MOVEM.L   (SP)+,D3-D7/A2-A6             Restore the context.
          RTS                                     Return.

QMENU     dc.w      5
          dc.b      'Menus',0

SCRAP     dc.w      16
          dc.b      'Scrap Extensions'

********************************************************************************
* Routines d'utilisation et de libration d'une chose:
* ===================================================
*
* Paramtres en entre: D0.L = $28 ou $29 (si appel de DO_THING),
* ~~~~~~~~~~~~~~~~~~~~  D1.L = Id du job concern (si appel de USE_THG),
*                       D2.L = Paramtre supplmentaire ventuel (selon chose),
*                       D3.L = Paramtre supplmentaire ventuel (si FREE_THG),
*                       A0.L = Pointeur sur le nom de la chose,
*                       A1.L = Paramtre supplmentaire ventuel (FREE_THG),
*                       A2.L = Paramtre supplmentaire ventuel (selon chose),
*
* Paramtres en sortie: D0.L = Code d'erreur,
* ~~~~~~~~~~~~~~~~~~~~  D1.L = Id du job concern (ou -1 si appel de FREE_THG),
*                       D2.L = Rsultat (selon la chose),
*                       D3.L = Version de la chose (si SMS.UTHG) ou prserv,
*                       D4.L  D7.L: prservs,
*                       A1.L = Pointeur sur la chose (si SMS.UTHG) ou prserv,
*                       A2.L = Ptr/bloc chanage chose (si SMS.UTHG) ou rsultat
*                       A0.L, A3.L  A7.L: prservs.

FREE_THG  MOVEQ     #-1,D1                        Job utilisateur=job courant.
          MOVEQ     #$29,D0                       Code pour appel  SMS.FTHG.
          BRA.S     DO_THG

USE_THING MOVEQ     #-1,D1                        Job utilisateur=job courant.
USE_THG   MOVEQ     #$28,D0                       Code pour appel  SMS.UTHG.
DO_THING  MOVEQ     #-1,D3                        Temporisation infinie.
DO_THG    MOVE.L    A4,-(SP)                      | Sauvegarder le contexte.
          MOVEM.L   D0/A0,-(SP)                   |
          BSR.S     SEARCH                        Chercher le vecteur "THING".
          MOVEM.L   (SP)+,D0/A0                   Restaurer ptr nom est code.
          BNE.S     DONE1                         Si erreur pas d'appel.
          JSR       (A4)                          Appel au vecteur "THING".
DONE1     MOVEA.L   (SP)+,A4                      Restaurer contexte.
          CMPI.L    #-7,D0                        Erreur "not found" ?
          BNE.S     DONE2                         Si non, sauter ce qui suit...
          MOVEQ     #-19,D0                       Code erreur "not implemented".
DONE2     TST.L     D0                            Positionner CCR.
          RTS                                     Retour.

********************************************************************************
* Routine de recherche de la chose "THING":
* ========================================
*
* Paramtres en entre: nant
* ~~~~~~~~~~~~~~~~~~~~
* Paramtres en sortie: A0.L=Adresse de "THING" (si D0=0),
* ~~~~~~~~~~~~~~~~~~~~  A4.L=Adresse de la routine "TH_ENTRY",
*                       D0.L=Code erreur (0: pas d'erreur, -19: non implment),
*
* Registres modifis  : D0, A0, A4.
* ~~~~~~~~~~~~~~~~~~

SEARCH    MOVEM.L   D1/D2,-(SP)                   Sauver le contexte.
          MOVEQ     #0,D0                         | Prendre les informations
          TRAP      #1                            | sur le systme.
          MOVEQ     #-19,D0                       Code erreur "non implment".
          LEA       $B8(A0),A0                    Pointeur sur liste des choses.
          MOVE.L    A0,D1                         Pointeur nul ?
          BEQ.S     SEARCH3                       Si oui, retour (pas de chose).
SEARCH1   MOVE.L    (A0),D1                       D1=Adresse du linkage block.
          BEQ.S     SEARCH2                       Si dernire chose, fin
          MOVEA.L   D1,A0                         | sinon poursuivre la recher-
          BRA.S     SEARCH1                       | che avec la chose suivante.
SEARCH2   MOVEA.L   16(A0),A0                     Pointeur sur chose elle-mme.
          CMPI.L    #'THG%',(A0)                  Est-ce bien une chose ?
          BNE.S     SEARCH3                       Si non, retour avec erreur.
          CMPI.L    #-1,4(A0)                     Est-ce la chose "THING" ?
          BNE.S     SEARCH3                       Si non, retour avec erreur.
          MOVEA.L   8(A0),A4                      Prendre le vecteur TH_ENTRY.
          MOVEQ     #0,D0                         Pas d'erreur.
SEARCH3   MOVEM.L   (SP)+,D1/D2                   Restaurer le contexte.
          TST.L     D0                            Positionner CCR.
          RTS                                     Retour.

          end
